#version 130

uniform sampler2D DiffuseSampler;
uniform sampler2D ParticlesDepthSampler;
uniform sampler2D TranslucentSampler;

in vec2 texCoord;
in vec2 oneTexel;
uniform mat4 ProjMat;
uniform vec2 InSize;
uniform vec2 OutSize;
uniform vec2 ScreenSize;
out vec4 fragColor;

uniform sampler2D BrightnessLimitMask;

const float offset = 0.5 / 300.0;  

void main(){

    vec2 offsets[9] = vec2[](
        vec2(-offset,  offset), // top-left
        vec2( 0.0f,    offset), // top-center
        vec2( offset,  offset), // top-right
        vec2(-offset,  0.0f),   // center-left
        vec2( 0.0f,    0.0f),   // center-center
        vec2( offset,  0.0f),   // center-right
        vec2(-offset, -offset), // bottom-left
        vec2( 0.0f,   -offset), // bottom-center
        vec2( offset, -offset)  // bottom-right    
    );

    float kernel[9] = float[](
        1, 1, 1,
        1, -8, 1,
        1, 1, 1
    );
    
    vec3 sampleTex[9];
    for(int i = 0; i < 9; i++)
    {
        sampleTex[i] = vec3(1.0-(1.0-texture2D(ParticlesDepthSampler, texCoord + offsets[i]))*80.0);
    }

    vec3 col = vec3(0.0);
    for(int i = 0; i < 9; i++)
        col += sampleTex[i] * kernel[i];
    
    fragColor = vec4( texture(DiffuseSampler, texCoord.st).rgb + ( (texture(DiffuseSampler, texCoord.st).rgb*clamp(col.r,0.,.8))), 1.0);

   //gl_FragColor = vec4(vec3(1.0-(1.0-texture(ParticlesDepthSampler, texCoord))*100.0), 1.0);
   
}